[(#REM)
/*
les input type color HTML5 propose au clic d'ouvrir le selecteur couleur du system/navigateur.

dans le cas d'une charte établie, on peut souhaiter proposer a l'utilisateur une liste de choix de couleurs.

l'attibut list="<datalist>", n'ayant pas un bon support navigateur, l'idée est donc de remplacer au clic les champs input:color par une liste et de renvoyer ensuite la valeur au champ d'origine;

- charge le swatch depuis un objet/json
- remplace de colorpiker par une palette imposée
- signale si la couleur actuelle est active
- mode popup css pour s'adapter a toute interface/conteneur ou périphérique
- peut modifier tout les input:color d'une page

*/
// Lib de colorPiker avec gestion des swatches
// https://github.com/Simonwep/pickr
// var userswatch = {
//   'Color 1': '#1F377F',
//   'Color 2': '#FF7851',
//   'Color 3': '#ED368D',
//   'Color 4': '#0D9CFF',
//   'Color 5': '#FFCA47',
//   'White': '#FFFFFF'
// };
]
function mypalette(swatch){
  var palette = $('<ul id="color_liste" class="colorswatch"></ul>');
  $.each(swatch,function(color,value){
    var list = $('<li class="color" data-color="'+value+'"></li>');
    var colorblock = $('<span class="swatch" style="background:'+value+'"></span>');
    var colorName = $('<span class="name">'+color+'</span>');
    list.append(colorblock,colorName);
    palette.append(list[0]);
  });

  var colorSwatch = $('<div id="popup_colorswatch"></div>').append(palette);

  return colorSwatch[0];
}

function colorPiker(){
  // Parcour les selecteurs déclencheurs
  $("[(#CONFIG{colorswatch/jquery_selectors})]").each(function(index,elem){
    var origin = $(elem); // le input à l'origine du clic
    var parent = origin.parent(); // conteneur du input déclencheur
    var actualColor = origin.val().toUpperCase() || "#FFFFFF"; // Couleur initiale du déclencheur

    // Evenement click
    origin.on('click',function(e){
      // Ne pas afficher le colorpicker du system
      e.preventDefault();
      // Ajout de la palette au conteneur
      parent.append(color_liste);
      // Pour chaque couleur de la palette
      $("#color_liste .color").each(function(index,elem){
          // récupérer l'attribut data-color forcer les majuscules pour une meilleur compat
          var color = $(elem).data('color').toUpperCase();
          // si la couleur est celle du déclencheur la signaler active
          (actualColor == color)
                ? $(elem).toggleClass('active')
                : $(elem).removeClass('active');
          // Quand on choisit la couleur
          $(elem).on('click', function(){
            // retire la palette
            parent.find("#popup_colorswatch").remove();
            // met a jour la valeur dans le déclencheur
            origin.val(color);
          });
      });
    });
  });
}

var color_liste;

function loadSwatch(){
    // Charger les données json
    $.getJSON("#URL_PAGE{colorswatch.json}").done(function(data) {
        // Construit la palette
        color_liste = mypalette(data);
        colorPiker();
    }).fail(function() {
      console.log( "Colorswatch : Error while loading json" );
    });
}

jQuery(window).on("load", function() {
  loadSwatch();
  onAjaxLoad(loadSwatch);
});
